valueerror意思 - 在Python中手動提高(拋出)異常




try pass python (4)

如何在Python中手動拋出/引發異常?

使用語義上適合您問題的最具體的Exception構造函數

具體在你的信息中,例如:

raise ValueError('A very specific bad thing happened.')

不要提出一般例外

避免提出一個通用的異常。 要捕捉它,你必須捕獲所有其他更具體的異常的子類。

問題1:隱藏錯誤

raise Exception('I know Python!') # Don't! If you catch, likely to hide bugs.

例如:

def demo_bad_catch():
    try:
        raise ValueError('Represents a hidden bug, do not catch this')
        raise Exception('This is the exception you expect to handle')
    except Exception as error:
        print('Caught this error: ' + repr(error))

>>> demo_bad_catch()
Caught this error: ValueError('Represents a hidden bug, do not catch this',)

問題2:不會趕上

更具體的漁獲量將不會捕捉到一般的例外情況:

def demo_no_catch():
    try:
        raise Exception('general exceptions not caught by specific handling')
    except ValueError as e:
        print('we will not catch exception: Exception')


>>> demo_no_catch()
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "<stdin>", line 3, in demo_no_catch
Exception: general exceptions not caught by specific handling

最佳實踐: raise聲明

相反,使用語義上適合您的問題的最具體的Exception構造函數

raise ValueError('A very specific bad thing happened')

它也可以輕鬆地將任意數量的參數傳遞給構造函數:

raise ValueError('A very specific bad thing happened', 'foo', 'bar', 'baz') 

這些參數可以通過Exception對象的args屬性來訪問。 例如:

try:
    some_code_that_may_raise_our_value_error()
except ValueError as err:
    print(err.args)

版畫

('message', 'foo', 'bar', 'baz')    

在Python 2.5中,實際的message屬性被添加到了BaseException中,以支持鼓勵用戶子類化異常並停止使用args ,但是message的引入和args的原始棄用已被撤消

最佳做法: except條款

例如,在except子句中,您可能想要記錄發生特定類型的錯誤,然後重新提升。 在保留堆棧跟踪的同時做到這一點的最好方法是使用裸加語句。 例如:

logger = logging.getLogger(__name__)

try:
    do_something_in_app_that_breaks_easily()
except AppError as error:
    logger.error(error)
    raise                 # just this!
    # raise AppError      # Don't do this, you'll lose the stack trace!

不要修改你的錯誤......但如果你堅持。

你可以使用sys.exc_info()來保存堆棧跟踪(和錯誤值),但是這種方式更容易出錯,並且在Python 2和Python 3之間存在兼容性問題 ,更喜歡使用裸機來重新升級。

解釋 - sys.exc_info()返回類型,值和回溯。

type, value, traceback = sys.exc_info()

這是Python 2中的語法 - 注意這與Python 3不兼容:

    raise AppError, error, sys.exc_info()[2] # avoid this.
    # Equivalently, as error *is* the second object:
    raise sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]

如果你願意,你可以修改你的新加註會發生什麼 - 例如為實例設置新的參數:

def error():
    raise ValueError('oops!')

def catch_error_modify_message():
    try:
        error()
    except ValueError:
        error_type, error_instance, traceback = sys.exc_info()
        error_instance.args = (error_instance.args[0] + ' <modification>',)
        raise error_type, error_instance, traceback

我們在修改參數時保留了整個回溯。 請注意,這不是最佳實踐 ,它在Python 3中是無效的語法 (使兼容性難以解決)。

>>> catch_error_modify_message()
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "<stdin>", line 3, in catch_error_modify_message
  File "<stdin>", line 2, in error
ValueError: oops! <modification>

Python 3中

    raise error.with_traceback(sys.exc_info()[2])

再次:避免手動操作回溯。 效率更低 ,更容易出錯。 如果你使用線程和sys.exc_info你甚至可能會得到錯誤的回溯(特別是如果你使用控制流的異常處理 - 我個人傾向於避免)。

Python 3,異常鏈接

在Python 3中,您可以鏈接異常,從而保留回溯:

    raise RuntimeError('specific message') from error

意識到:

  • 確實允許更改提出的錯誤類型,並且
  • 這與Python 2 兼容。

已棄用的方法:

這些可以很容易地隱藏甚至進入生產代碼。 你想提出一個異常,做這些異常會引發一個異常, 但不是預期的異常

在Python 2中有效,但在Python 3中不適用如下:

raise ValueError, 'message' # Don't do this, it's deprecated!

只有在較老版本的Python (2.4及更低版本)中有效 ,您仍然可以看到有人在提升字符串:

raise 'message' # really really wrong. don't do this.

在所有的現代版本中,這實際上會引發一個TypeError,因為你沒有引發一個BaseException類型。 如果您沒有檢查正確的例外情況,並且沒有意識到問題的審核人員,它可能會投入生產。

使用示例

如果他們錯誤地使用它,我會提出異常來警告消費者我的API:

def api_func(foo):
    '''foo should be either 'baz' or 'bar'. returns something very useful.'''
    if foo not in _ALLOWED_ARGS:
        raise ValueError('{foo} wrong, use "baz" or "bar"'.format(foo=repr(foo)))

apropos時創建您自己的錯誤類型

“我想故意犯錯,所以它會進入除了”

你可以創建你自己的錯誤類型,如果你想指出你的應用程序有特定的錯誤,只需在異常層次結構中對適當的點進行子類化:

class MyAppLookupError(LookupError):
    '''raise this when there's a lookup error for my app'''

和用法:

if important_key not in resource_dict and not ok_to_be_missing:
    raise MyAppLookupError('resource is missing, and that is not ok.')

我如何在Python中引發異常,以便稍後可以通過except塊捕獲它?


不要這樣做 。 提出一個光明的Exception絕對不是正確的做法; 相反,請參閱share 。

不能得到比這更pythonic:

raise Exception("I know python!")

如果您想了解更多信息,請參閱python 的raise語句文檔


在Python3中,有4種不同的語法來處理異常:

1. raise exception 
2. raise exception (args) 
3. raise
4. raise exception (args) from original_exception

1.引發異常與2.引發異常(args)

如果使用raise exception (args)引發異常,則在打印異常對象時將打印args - 如下例所示。

  #raise exception (args)
    try:
        raise ValueError("I have raised an Exception")
    except ValueError as exp:
        print ("Error", exp)     # Output -> Error I have raised an Exception 



  #raise execption 
    try:
        raise ValueError
    except ValueError as exp:
        print ("Error", exp)     # Output -> Error 

3.raise

raise沒有任何論據的情況下raise陳述會重新提出最後一個異常 如果您需要在捕捉異常之後執行一些操作,然後再重新提升它,這非常有用。 但如果之前沒有異常, raise語句會引發TypeError異常。

def somefunction():
    print("some cleaning")

a=10
b=0 
result=None

try:
    result=a/b
    print(result)

except Exception:            #Output ->
    somefunction()           #some cleaning
    raise                    #Traceback (most recent call last):
                             #File "python", line 8, in <module>
                             #ZeroDivisionError: division by zero

4.從original_exception中引發異常(參數)

該語句用於創建異常鏈,在異常鏈中響應另一個異常而引發的異常可以包含原始異常的詳細信息 - 如下例所示。

class MyCustomException(Exception):
pass

a=10
b=0 
reuslt=None
try:
    try:
        result=a/b

    except ZeroDivisionError as exp:
        print("ZeroDivisionError -- ",exp)
        raise MyCustomException("Zero Division ") from exp

except MyCustomException as exp:
        print("MyException",exp)
        print(exp.__cause__)

輸出:

ZeroDivisionError --  division by zero
MyException Zero Division 
division by zero

對於常見的情況,您需要針對某些意外情況拋出異常,並且您從不打算捕捉異常,但僅僅是為了快速失敗,以便能夠從此處進行調試 - 最合乎邏輯的一次似乎是AssertionError

if 0 < distance <= RADIUS:
    #Do something.
elif RADIUS < distance:
    #Do something.
else:
    raise AssertionError("Unexpected value of 'distance'!", distance)






exception-handling